// C Header File
// Created 10/03/2003; 10:12:09

/*----------------------------------------------------------
Cre un nom du tios  partir d'une chane de caractres en C
Retourne le pointeur de fin du nom du fichier
-----------------------------------------------------------*/
char* GenerateTIOSName(char* cname,char* buffer) {
    buffer[0] = 0;
    return (strcpy(buffer + 1, cname) + strlen(cname));
}


/*-----------------------------------------------------
Renvoie un SYM_ENTRY  partir d'une chane de caractre
-------------------------------------------------------*/
SYM_ENTRY* GetSymByName(char* name) {
    char buf[50];
    HSym hs;

    if (*name) hs = SymFind(GenerateTIOSName(name,buf));  /* cname    */
    else       hs = SymFind(name);                        /* tiosname */

    if (!hs.folder) return NULL;
    else            return DerefSym(hs);
}

unsigned short FileSize(char *file) {return 2+*(unsigned short*)file;}


//Renvoie 'extension personnalise
unsigned char *Get_OtherExt(char *file)
{
	unsigned char *ptr;
	ptr=file+FileSize(file)-2;
	
	if (file!=NULL && *(ptr+1)==OTH_TAG)
	{
		while (*(--ptr)!=0);
		return ptr+1;
	}
	
	return NULL;
}


//Recherche tout les fichiers audio et ajoute dans la liste des fichiers
void FindAudioFile(struct ListAudio *lst)
{
	SYM_ENTRY *entry_folder;
	SYM_ENTRY *entry_file;
	char buffer[50];
	unsigned char **lst_folder;
	unsigned char **lst_file;
	unsigned char nbr_folder=0;
	unsigned char nbr_file=0;
	unsigned char tempfile[17];
	unsigned char *ptr;
	
	int i=0;
	
	//Alloue la liste des dossier (ici on prend au max 50 dossiers)
	lst_folder=malloc(sizeof(char)*8*50);
	
	//Parcours de la VAT
	entry_folder=SymFindFirst(NULL,FO_SKIP_TEMPS);
	while (entry_folder != NULL)
	{
		lst_folder[nbr_folder++]=entry_folder->name;
		entry_folder=SymFindNext();
	}
	
	//Alloue la liste des fichiers (ici on prend 50 fichiers max)
	lst_file=malloc(sizeof(char)*18*50);
	for (i=0;i<nbr_folder;i++)
	{
		entry_file=SymFindFirst(GenerateTIOSName(lst_folder[i],buffer),9);
		while (entry_file != NULL)
		{
			memset(tempfile,0,17);
			memcpy(tempfile,lst_folder[i],strlen(lst_folder[i]));
			strcat(tempfile,"\\");
			strcat(tempfile,entry_file->name);
			
			if ((unsigned char)(peek(HToESI(entry_file->handle)))==OTH_TAG)
			{
				ptr=HeapDeref(entry_file->handle);
						
				if (!strcmp (Get_OtherExt(ptr),"mus")) memcpy (lst->ptr+18*nbr_file++,tempfile,18);
			}
			
			entry_file=SymFindNext();
		}
	}
	
	lst->size=nbr_file;
	
	//On libre les listes temporaire
	free(lst_folder);
	free(lst_file);
}

//---------------------------------------------------------------------------------
//void *SetFile (struct ListAudio *lst,unsigned char FilePtr)
//---------------------------------------------------------------------------------
//Extrait le fichier pointe dans la ListAudio est enregistre c'est paramtres dans
//la structure.
//
//Renvoie NULL si le fichier possde une erreur.
//----------------------------------------------------------------------------------

void *SetFile (struct ListAudio *lst,unsigned char FilePtr)
{
	SYM_ENTRY *entry;
	void *ptr;

	unsigned char counter=0,flag;
	unsigned long size,_start;
	
	//Si le pointeur est diffrent de NULL on le libre donc on efface l'ancien fichier dcompress
	if (lst->PtrFile !=NULL) free (lst->PtrFile);
	
	//On le met  NULL
	lst->PtrFile=NULL;
	
	//Donne le pointeur du fichier FilePtr
	entry=GetSymByName (lst->ptr+18*FilePtr);
	
	//Si il n'existe pas on return NULL
	if (!entry->handle) return NULL;
	
	//Si c'est on bon on obtient le pointeur du handle
	ptr=HeapDeref(entry->handle)+2;
	
	//On vrifie si le fichier est valide, si pas le cas on return NULL
	if (!ttarchive_valid(ptr)) return NULL;
	
	//On voit ce que donne la taille du fichier aps dcompression pour allouer de la mmoire
	size=ttunpack_size(ptr+22);
	
	//Si on peut pas allouer de la mmoire on return NULL
	if (!(lst->PtrFile = malloc(size))) return NULL;

	//On dcompresse, si erreur on libre l'espace allou, on met le pointeur  NULL et on return NULL
	if (ttunpack_decompress(ptr+22,lst->PtrFile) != TTUNPACK_OKAY) {
  	free(lst->PtrFile);
    lst->PtrFile=NULL;
    return NULL;
  }

	
	//Si c'est bon on met le n du fichier en cours
	ptr=lst->PtrFile;
	
	//On positionne _start au dbut des ifnos du fichier
	_start=size-2;
	
	//On parcours le fichier octet par octet, si on obtient un octet NULL on enregistre l'infos.
	while (counter<5 || *(BYTE*)(ptr+_start)!=255)
	{
		if (*(BYTE*)(ptr+_start)==0)
		{
			if (counter==0) lst->_Comment=(ptr+_start)+1;
			else if (counter==1) lst->_Compositeur=(ptr+_start)+1;
			else if (counter==2) lst->_Auteur=(ptr+_start)+1;
			else if (counter==3) lst->_Description=(ptr+_start)+1;
			else if (counter==4) lst->_Name=(ptr+_start)+1;
			
			counter++;
		}
		
		_start--;
	}
	
	//Dans flag on enregistre le flag des voies 1 ou 2.
	flag=*(BYTE*)(ptr);
	counter=0;
	_start=3;
	
	//Le pointeur du channel2 est mis automatiquement  NULL
	lst->channel[1]=NULL;
	lst->channel_end[1]=NULL;
	
	//Comme dans ce genre de fichiers il y a au moins un canal on le prend
	lst->channel[0]=ptr+3;
	
	//Si il y a 2 canaux
	if (flag==2) { 
		
		//On parcourt tout le canal1 pour trouver le dbut du canal2, on sais qu'un canal ce termine par 255
		while (1)	{
		if (*(BYTE*)(ptr+_start)==255)  {lst->channel[1]=ptr+_start+1; break;}
		
		_start+=2;}
	}
	
	//Pointeur de fin de channel0
	lst->channel_end[0]=ptr+_start;
	
	_start++;
	
	if (flag==2) {
		
		//On parcourt tout le canal1 pour trouver la fin du canal2, on sais qu'un canal ce termine par 255
		while (1)	{
		if (*(BYTE*)(ptr+_start)==255)  {lst->channel_end[1]=ptr+_start; break;}
		
		_start+=2;}
	}
	
	//n renvoie le pointeur du fichier
	return lst->PtrFile;
}

//Renvoie le tempo contenu dans le fichier
unsigned short GetTempo (void *ptr)
{
	//J'ai pas trouv une meilleur mthode donc j'extrait 2 octets pour former un short.
	
	unsigned char tmp[2];
	tmp[0]=*(BYTE*)(ptr+1);	tmp[1]=*(BYTE*)(ptr+2);
	return *(unsigned short*)(tmp);
}


//Renvoie le temps necessaire pour jouer la musique
unsigned short GetTime_ (struct ListAudio *lst)
{
	unsigned short time1,time2=0;
	
	time1=pSnd_GetTime (lst->channel[0],lst->tempo);
	
	if (lst->channel[1]) time2=pSnd_GetTime (lst->channel[1],lst->tempo);
	
	if (time2>time1) {lst->MaxTime=2; lst->time=time2; return time2;}
	lst->MaxTime=1;
	lst->time=time1;
	return time1;
}


//Selection un fichier si ereur on efface les zones de mmoire allou et on quitte le player.
void SetFile2 (struct ListAudio *lst,unsigned char pFile)
{
	void *ptr=NULL;
	
	if (!(ptr=SetFile (lst,pFile))) {
		if (lst->PtrFile) free (lst->PtrFile);
		free (lst->ptr); free (lst);
		CreateDlgError ("File ERROR","Error opening file.","The file as a format no valid.");
		DesinstallInterrupts (TRUE);
		exit(0);}
	
	lst->tempo=GetTempo (lst->PtrFile);
	
	//On arrte la librairie PolySnd	
	pSnd_SetState (NOVOICE);
	
	//On actualise les infos et la fentre des fichiers	
	SetFileInDialog (lst,pFile);
	DrawInfoFile (lst);
	
	SetProgressBar (FileList,0);
	
	//Case  cocher (MONO ou STEREO)
	DrawGrayRect (CHECK1_X0+2,CHECK1_Y0+2,CHECK1_X0+2+3,CHECK1_Y0+2+3,COLOR_WHITE,RECT_FILLED);
	DrawGrayRect (CHECK2_X0+2,CHECK2_Y0+2,CHECK2_X0+2+3,CHECK2_Y0+2+3,COLOR_WHITE,RECT_FILLED);
	
	if (*(BYTE*)(ptr)==0x02) 
		DrawGrayRect (CHECK2_X0+2,CHECK2_Y0+2,CHECK2_X0+2+3,CHECK2_Y0+2+3,COLOR_DARKGRAY,RECT_FILLED);
	else
		DrawGrayRect (CHECK1_X0+2,CHECK1_Y0+2,CHECK1_X0+2+3,CHECK1_Y0+2+3,COLOR_DARKGRAY,RECT_FILLED);
}


//Renvoie le temps sous la forme mm:ss
//Ici j'ai pris la mthode la plus barbare qui est de faire un for et d'incrmenter des variable
char *GetFormattedTime (unsigned short time)
{
	unsigned short i;
	unsigned char *buffer="     ";
	
	unsigned char sec_d=0;
	unsigned char sec_u=0;
	
	unsigned char min_u=0;
	unsigned char min_d=0;
	
	for (i=1; i<=time; i++)
	{
		sec_u++;
		
		if (sec_u==10) {sec_d++; sec_u=0;}
		if (sec_d==6) {min_u++; sec_d=0;}
		if (min_u==10) {min_d++; min_u=0;}
	}
	
	if (min_d>9) {min_d=9; min_u=9; sec_d=9; sec_u=9;}
	
	memset (buffer,(min_d+48),1);
	memset (buffer+1,(min_u+48),1);
	memset (buffer+2,':',1);
	memset (buffer+3,(sec_d+48),1);
	memset (buffer+4,(sec_u+48),1);
		
	return buffer;
}

unsigned char *GetFileName (struct ListAudio *lst, unsigned char FilePtr) {return lst->ptr+18*FilePtr;}

//Initialise les infos du player...
void InitializePlayer (void)
{
	OldInt1 = GetIntVec (AUTO_INT_1);
	OldInt2 = GetIntVec (AUTO_INT_2);
	SetIntVec (AUTO_INT_1, Player_Timer);
  SetIntVec (AUTO_INT_2, DUMMY_HANDLER);
  
  counter1=0; counter2=0;
  
	pCommand=0; pFile=0; previous_item=0;
	scrollbar_debut=0;
	time=0;
	cmd_Play=FALSE;
	cmd_Shuffle=FALSE;
	
	BR1=0; BR2=0; BR3=0; BR4=0; BR5=0; BR6=0; BR7=0; BR8=0;
	BRN=1;
	
	vol1=0; vol2=0;
	yosc1=70; yosc2=84;
	
	volbit1=1; volbit2=1;
	
	USE_GRAY_WITH_POLYSND;
	GrayOn();
	
	ClearGrayScreen();
	DrawEnv ();
	
  //Alloue de la mmoire pour sauvegarde temporaire
  if ((FileList = (struct ListAudio *)calloc(1,sizeof(struct ListAudio))) == NULL) {
		CreateDlgError ("Memory ERROR","Not enought memory.","");
		DesinstallInterrupts (FALSE);
		exit(0);}
  
  //Alloue de la mmoire pour la liste des fichiers
  if ((FileList->ptr=malloc(sizeof(char)*17*70))==NULL) {
  	free (FileList);
  	CreateDlgError ("Memory ERROR","Not enought memory.","");
		DesinstallInterrupts (FALSE);
		exit(0);}
	
	//Alloue la liste audio
	FindAudioFile(FileList);
	
	//Si y a pas de fichier donc 0 on quitte
	if (!FileList->size) {
		free(FileList->ptr); free(FileList);
		CreateDlgError ("No files","There are no files for PolySnd Player.","You must send songs files.");
		DesinstallInterrupts (FALSE);
		exit(0);}
	
		//Install PolySnd v2.0
	pSnd_EnableSound ();
	pSnd_InstallSound ();
	
	pSnd_Interrupt5 (Player_Timer2);
	
	//Dessine les infos...	
	DrawFileList (FileList,0);
	SetFile2 (FileList,0);
	SelectFile (0);
	SetPosScrollBar (FileList,0);
}

void UninstallPlayer (void)
{
	//unsinstall PolySnd v2.0
	pSnd_UninstallSound ();
	pSnd_DisableSound ();
	
	GrayOff();
	
	//On libre la mmoire utilise.
	if (FileList->PtrFile) free (FileList->PtrFile);
	free(FileList->ptr); free(FileList);
	
	SetIntVec (AUTO_INT_1, OldInt1);
	SetIntVec (AUTO_INT_2, OldInt2);
}

unsigned short CalculateTime (void *start,void *end)
{
	unsigned short calc_time=0;
	
	while (start<end)
	{
		calc_time+=*(BYTE*)(++start);
		start++;
	}
	
	calc_time=((calc_time/32)*60)/FileList->tempo;
		
	return calc_time;
}